library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

entity nexys4_accel_sim_bench is
end nexys4_accel_sim_bench;

architecture Behavioral of nexys4_accel_sim_bench is

component accel is port(
	clk	: in std_logic;
	accel_CLK : out std_logic;
	accel_MOSI : out std_logic;
	accel_MISO : in std_logic;
	aclSS : out std_logic;
	accel_X : out std_logic_vector(11 downto 0);
	accel_Y : out std_logic_vector(11 downto 0);
	accel_Z : out std_logic_vector(11 downto 0);
	start_out : out std_logic);
end component;

signal clk_in: std_logic:='0';
constant clk_in_half_period: time := 5 ns;
signal accel_CLK_out, accel_MOSI_out, accel_MISO_in, aclSS_out, start_out: std_logic:='0';
signal X, Y, Z:std_logic_vector(11 downto 0):=(others => '0');
constant XYZ_MISO: std_logic_vector(47 downto 0):="100001011111011100111000111101101110101111110100";
signal bitcounter: integer range 0 to 47:=0;
signal state: integer range 0 to 2:=0;

begin

a0: accel port map(
	clk	=> clk_in,
	accel_CLK => accel_CLK_out,
	accel_MOSI => accel_MOSI_out,
	accel_MISO => accel_MISO_in,
	aclSS => aclSS_out,
	accel_X => X,
	accel_Y => Y,
	accel_Z => Z,
	start_out => start_out);

clk_in <= not clk_in after clk_in_half_period;

process begin
-- X: 123
-- Y: 456  
-- Z: 789 
-- XYZ: "100001011111011100111000111101101110101111110100"

if    state = 0 then
	state <= 1;
	wait for 1.365 us;
end if;
if state = 1 then
	accel_MISO_in <= XYZ_MISO(47 - bitcounter);
	bitcounter <= bitcounter +1;
	wait for 80 ns;
	if bitcounter = 47 then
		state <= 2;
	end if;
end if;
if state = 2 then
	wait;
end if;
end process;

end Behavioral;